package com.rebusland.fin.derivatives.eq.server.output.model;

import java.util.List;

import org.joda.beans.ImmutableBean;
import org.joda.beans.gen.BeanDefinition;
import org.joda.beans.gen.PropertyDefinition;

import com.google.common.collect.ImmutableList;
import com.rebusland.fin.derivatives.eq.server.common.model.SerializableBeanFacade;
import java.util.Map;
import java.util.NoSuchElementException;
import org.joda.beans.Bean;
import org.joda.beans.JodaBeanUtils;
import org.joda.beans.MetaBean;
import org.joda.beans.MetaProperty;
import org.joda.beans.impl.direct.DirectFieldsBeanBuilder;
import org.joda.beans.impl.direct.DirectMetaBean;
import org.joda.beans.impl.direct.DirectMetaProperty;
import org.joda.beans.impl.direct.DirectMetaPropertyMap;

@BeanDefinition
public class FairPricingOutput extends SerializableBeanFacade implements ImmutableBean {
	@PropertyDefinition(validate = "notNull")
	private final Double fair;

	@PropertyDefinition(validate = "notNull")
	private final Double monteCarloError;

	@PropertyDefinition
	private final List<Double> moments;

	//------------------------- AUTOGENERATED START -------------------------
	/**
	 * The meta-bean for {@code FairPricingOutput}.
	 * @return the meta-bean, not null
	 */
	public static FairPricingOutput.Meta meta() {
		return FairPricingOutput.Meta.INSTANCE;
	}

	static {
		MetaBean.register(FairPricingOutput.Meta.INSTANCE);
	}

	/**
	 * Returns a builder used to create an instance of the bean.
	 * @return the builder, not null
	 */
	public static FairPricingOutput.Builder builder() {
		return new FairPricingOutput.Builder();
	}

	/**
	 * Restricted constructor.
	 * @param builder  the builder to copy from, not null
	 */
	protected FairPricingOutput(FairPricingOutput.Builder builder) {
		JodaBeanUtils.notNull(builder.fair, "fair");
		JodaBeanUtils.notNull(builder.monteCarloError, "monteCarloError");
		this.fair = builder.fair;
		this.monteCarloError = builder.monteCarloError;
		this.moments = (builder.moments != null ? ImmutableList.copyOf(builder.moments) : null);
	}

	@Override
	public FairPricingOutput.Meta metaBean() {
		return FairPricingOutput.Meta.INSTANCE;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the fair.
	 * @return the value of the property, not null
	 */
	public Double getFair() {
		return fair;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the monteCarloError.
	 * @return the value of the property, not null
	 */
	public Double getMonteCarloError() {
		return monteCarloError;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the moments.
	 * @return the value of the property
	 */
	public List<Double> getMoments() {
		return moments;
	}

	//-----------------------------------------------------------------------
	/**
	 * Returns a builder that allows this bean to be mutated.
	 * @return the mutable builder, not null
	 */
	public Builder toBuilder() {
		return new Builder(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj != null && obj.getClass() == this.getClass()) {
			FairPricingOutput other = (FairPricingOutput) obj;
			return JodaBeanUtils.equal(fair, other.fair) &&
					JodaBeanUtils.equal(monteCarloError, other.monteCarloError) &&
					JodaBeanUtils.equal(moments, other.moments);
		}
		return false;
	}

	@Override
	public int hashCode() {
		int hash = getClass().hashCode();
		hash = hash * 31 + JodaBeanUtils.hashCode(fair);
		hash = hash * 31 + JodaBeanUtils.hashCode(monteCarloError);
		hash = hash * 31 + JodaBeanUtils.hashCode(moments);
		return hash;
	}

	@Override
	public String toString() {
		StringBuilder buf = new StringBuilder(128);
		buf.append("FairPricingOutput{");
		int len = buf.length();
		toString(buf);
		if (buf.length() > len) {
			buf.setLength(buf.length() - 2);
		}
		buf.append('}');
		return buf.toString();
	}

	protected void toString(StringBuilder buf) {
		buf.append("fair").append('=').append(JodaBeanUtils.toString(fair)).append(',').append(' ');
		buf.append("monteCarloError").append('=').append(JodaBeanUtils.toString(monteCarloError)).append(',').append(' ');
		buf.append("moments").append('=').append(JodaBeanUtils.toString(moments)).append(',').append(' ');
	}

	//-----------------------------------------------------------------------
	/**
	 * The meta-bean for {@code FairPricingOutput}.
	 */
	public static class Meta extends DirectMetaBean {
		/**
		 * The singleton instance of the meta-bean.
		 */
		static final Meta INSTANCE = new Meta();

		/**
		 * The meta-property for the {@code fair} property.
		 */
		private final MetaProperty<Double> fair = DirectMetaProperty.ofImmutable(
				this, "fair", FairPricingOutput.class, Double.class);
		/**
		 * The meta-property for the {@code monteCarloError} property.
		 */
		private final MetaProperty<Double> monteCarloError = DirectMetaProperty.ofImmutable(
				this, "monteCarloError", FairPricingOutput.class, Double.class);
		/**
		 * The meta-property for the {@code moments} property.
		 */
		@SuppressWarnings({"unchecked", "rawtypes" })
		private final MetaProperty<List<Double>> moments = DirectMetaProperty.ofImmutable(
				this, "moments", FairPricingOutput.class, (Class) List.class);
		/**
		 * The meta-properties.
		 */
		private final Map<String, MetaProperty<?>> metaPropertyMap$ = new DirectMetaPropertyMap(
				this, null,
				"fair",
				"monteCarloError",
				"moments");

		/**
		 * Restricted constructor.
		 */
		protected Meta() {
		}

		@Override
		protected MetaProperty<?> metaPropertyGet(String propertyName) {
			switch (propertyName.hashCode()) {
				case 3135268:  // fair
					return fair;
				case 1519803982:  // monteCarloError
					return monteCarloError;
				case 1235271283:  // moments
					return moments;
			}
			return super.metaPropertyGet(propertyName);
		}

		@Override
		public FairPricingOutput.Builder builder() {
			return new FairPricingOutput.Builder();
		}

		@Override
		public Class<? extends FairPricingOutput> beanType() {
			return FairPricingOutput.class;
		}

		@Override
		public Map<String, MetaProperty<?>> metaPropertyMap() {
			return metaPropertyMap$;
		}

		//-----------------------------------------------------------------------
		/**
		 * The meta-property for the {@code fair} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Double> fair() {
			return fair;
		}

		/**
		 * The meta-property for the {@code monteCarloError} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Double> monteCarloError() {
			return monteCarloError;
		}

		/**
		 * The meta-property for the {@code moments} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<List<Double>> moments() {
			return moments;
		}

		//-----------------------------------------------------------------------
		@Override
		protected Object propertyGet(Bean bean, String propertyName, boolean quiet) {
			switch (propertyName.hashCode()) {
				case 3135268:  // fair
					return ((FairPricingOutput) bean).getFair();
				case 1519803982:  // monteCarloError
					return ((FairPricingOutput) bean).getMonteCarloError();
				case 1235271283:  // moments
					return ((FairPricingOutput) bean).getMoments();
			}
			return super.propertyGet(bean, propertyName, quiet);
		}

		@Override
		protected void propertySet(Bean bean, String propertyName, Object newValue, boolean quiet) {
			metaProperty(propertyName);
			if (quiet) {
				return;
			}
			throw new UnsupportedOperationException("Property cannot be written: " + propertyName);
		}

	}

	//-----------------------------------------------------------------------
	/**
	 * The bean-builder for {@code FairPricingOutput}.
	 */
	public static class Builder extends DirectFieldsBeanBuilder<FairPricingOutput> {

		private Double fair;
		private Double monteCarloError;
		private List<Double> moments;

		/**
		 * Restricted constructor.
		 */
		protected Builder() {
		}

		/**
		 * Restricted copy constructor.
		 * @param beanToCopy  the bean to copy from, not null
		 */
		protected Builder(FairPricingOutput beanToCopy) {
			this.fair = beanToCopy.getFair();
			this.monteCarloError = beanToCopy.getMonteCarloError();
			this.moments = (beanToCopy.getMoments() != null ? ImmutableList.copyOf(beanToCopy.getMoments()) : null);
		}

		//-----------------------------------------------------------------------
		@Override
		public Object get(String propertyName) {
			switch (propertyName.hashCode()) {
				case 3135268:  // fair
					return fair;
				case 1519803982:  // monteCarloError
					return monteCarloError;
				case 1235271283:  // moments
					return moments;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
		}

		@SuppressWarnings("unchecked")
		@Override
		public Builder set(String propertyName, Object newValue) {
			switch (propertyName.hashCode()) {
				case 3135268:  // fair
					this.fair = (Double) newValue;
					break;
				case 1519803982:  // monteCarloError
					this.monteCarloError = (Double) newValue;
					break;
				case 1235271283:  // moments
					this.moments = (List<Double>) newValue;
					break;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
			return this;
		}

		@Override
		public Builder set(MetaProperty<?> property, Object value) {
			super.set(property, value);
			return this;
		}

		@Override
		public FairPricingOutput build() {
			return new FairPricingOutput(this);
		}

		//-----------------------------------------------------------------------
		/**
		 * Sets the fair.
		 * @param fair  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder fair(Double fair) {
			JodaBeanUtils.notNull(fair, "fair");
			this.fair = fair;
			return this;
		}

		/**
		 * Sets the monteCarloError.
		 * @param monteCarloError  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder monteCarloError(Double monteCarloError) {
			JodaBeanUtils.notNull(monteCarloError, "monteCarloError");
			this.monteCarloError = monteCarloError;
			return this;
		}

		/**
		 * Sets the moments.
		 * @param moments  the new value
		 * @return this, for chaining, not null
		 */
		public Builder moments(List<Double> moments) {
			this.moments = moments;
			return this;
		}

		/**
		 * Sets the {@code moments} property in the builder
		 * from an array of objects.
		 * @param moments  the new value
		 * @return this, for chaining, not null
		 */
		public Builder moments(Double... moments) {
			return moments(ImmutableList.copyOf(moments));
		}

		//-----------------------------------------------------------------------
		@Override
		public String toString() {
			StringBuilder buf = new StringBuilder(128);
			buf.append("FairPricingOutput.Builder{");
			int len = buf.length();
			toString(buf);
			if (buf.length() > len) {
				buf.setLength(buf.length() - 2);
			}
			buf.append('}');
			return buf.toString();
		}

		protected void toString(StringBuilder buf) {
			buf.append("fair").append('=').append(JodaBeanUtils.toString(fair)).append(',').append(' ');
			buf.append("monteCarloError").append('=').append(JodaBeanUtils.toString(monteCarloError)).append(',').append(' ');
			buf.append("moments").append('=').append(JodaBeanUtils.toString(moments)).append(',').append(' ');
		}

	}

	//-------------------------- AUTOGENERATED END --------------------------
}
